/* editgrep    ... by Cindy Ross                                           */
/*                                                                         */
/*    - Requires grepfilt and a grep.exe program                           */
/*                                                                         */
/* This program uses grep to search files for a regular expresssion, and   */
/* then loads XWNT with the files containing the expression.  The lines    */
/* containing the expression are highlighted with error comments, so you   */
/* can then simply use ctrl-N to navigate to the matching lines.           */
/*                                                                         */
/* This program works with at least two publicly available grep programs   */
/* (as long as they're renamed to grep.exe).  Grep32 is available from:    */
/*                                                                         */
/*    http://www.vntalk.com/freewarez/page1                                */
/*    http://www.warezclan.com/appz.htm                                    */
/*    http://mint-hpvac.com/appz/appz.html                                 */
/*                                                                         */
/* Or grep20b_win is available from:                                       */
/*                                                                         */
/*    http://www.interlog.com/~tcharron/grep.html                          */
/*                                                                         */
/* You invoke editgrep from the Windows command prompt with the same       */
/* parameters that you would normally pass directly to grep, for example:  */
/*                                                                         */
/*    editgrep -s "printf" *.c                                             */
/*                                                                         */
/* (The grepfilt.rex program is a "subroutine" for editgrep.rex; it is not */
/* intended to be invoked explicitly.)                                     */
/*                                                                         */
/***************************************************************************/

signal on novalue

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

parse arg allargs

tempdir = value( 'TEMP', , 'ENVIRONMENT' )
if ( tempdir = '' ) then tempdir = 'C:\'
template = strip( tempdir, 'T', '\' ) || '\????.err'
errorfile = SysTempFileName( template )

'@grep.exe -n 'allargs'| rexx grepfilt >'errorfile

'@xwnt.exe /err 'errorfile

call SysFileDelete errorfile

