/***************************************************************************/
/*                                                                         */
/* APIWIN.X                                                                */
/*                                                                         */
/* Display a list of function prototypes that match the keyword at the     */
/* cursor location.  A replacement for the old builtin APIWIN editor       */
/* command, which was assigned to Ctrl-F6.                                 */
/*                                                                         */
/* Written by Blair Thompson, March 9, 1999                                */
/* Allow multiple files, semi-colon delimited (C. Ross), January 10, 2000  */
/*                                                                         */
/***************************************************************************/

  'EXTRACT /APIFILE/'
  If apifile.1 = ''
    Then Do
      'MSG No API file defined for this file extension'
      Exit
    End                                                           /* End do*/

  'CURSOR DATA'
  'EXTRACT /CURSOR/'
  csr = cursor.1 cursor.2
  'PREVIOUS_SYM'
  'EXTRACT /CURSOR/'
  'EXTRACT /CURLINE/'
  keyword = Substr(curline.1,cursor.2,word(csr,2)-cursor.2)
  'CURSOR' csr

  files.0 = 0
  do forever
    p = lastpos( '\', apifile.1 )
    if p <> 0 then
    do
      path = left( apifile.1, p )
      apifile.1 = substr( apifile.1, p+1 )
    end
    parse value apifile.1 with thisfile';'apifile.1
    thisfile = strip(thisfile)
    if thisfile = '' then
    do
      leave
    end
    files.0 = files.0 + 1
    call value 'files.'files.0, path||thisfile
  end

  winctr = 0

  do i = 1 to files.0
    'EDIT' files.i
    If rc <> 0
      Then Do                                      /* Error finding the file?*/
        'QUIT'
        'MESSAGEBOX' 'Defined API file' files.i 'not found'
        iterate
      End                                                           /* End do*/
    'ALL /'keyword'/ f'
    rc1 = rc
    'RESTORE_FIND'
    'ALL /= 'keyword'/ +'
    rc2 = rc
    'RESTORE_FIND'
    If ( rc1 = 0 ) | ( rc2 = 0 )
      Then Do
        'TOP'
        'SHADOW OFF'
        Do Forever
          'EXTRACT /CURLINE/'
          winctr = winctr + 1
          winline.winctr = curline.1
          'DOWN 1'
          If rc <> 0
            Then Leave
        End                                                         /* End do*/
      End                                                           /* End do*/
    'QUIT'                                      /* We no longer need API file*/
  end

  If winctr = 0
    Then Do
      'MSG No matching APIs found'
      Exit
    End                                                           /* End do*/

  'WINDOW 10 50' winctr 'API Expansion List'
  Do ctr = 1 To winctr
    'WINLINE' winline.ctr'\nSETRESULT' ctr
  End                                                             /* End do*/
  'WINWAIT'
  If rc <> 0
    Then Exit

  'CURSOR' cursor.1 cursor.2
  Do Length(keyword)                                /* Remove existing text*/
    'DELCHAR'
  End                                                             /* End do*/
  'KEYIN' winline.result                                    /* Add new text*/
Exit
