/***********************************************************************/
/* BRAC.X    by Rob Johnston                                           */
/***********************************************************************/
/* This macro will mark all lines between an open bracket "{" and the  */
/* matching close "}" bracket. The open bracket must be on the current */
/* line.                                                               */
/***********************************************************************/
rc = 0
  'EXTRACT /CURLINE/'                                   /* Get current line*/

  temp = curline.1

/***********************************************************************/
/* lets see if there is an open {                                      */
/***********************************************************************/

    If pos('{',temp) = 0 then do
      'MSG No open bracket on this line'
      return
    end

    'MARK CLEAR'                       /* In case there was a previous mark*/
/***********************************************************************/
/* We found an open bracket so set the bracket count to 1 and mark the */
/* current line                                                        */
/***********************************************************************/
    numofbrackets = 1
    'MARK LINE'

/***********************************************************************/
/* lets scroll                                                         */
/***********************************************************************/
    Do while numofbrackets <> 0
       'DOWN'
       If rc <> 0
         Then do
           /* *************************************************** */
           /* We found the end of file before the closing bracket */
           /* *************************************************** */
           'MSG Unbalanced brackets. No closing found in file.'
           return
         end

       'EXTRACT /CURLINE/'                        /* Get current line*/
       temp = curline.1

       If pos('{',temp) <> 0 then         /* Increase count for opens */
         numofbrackets= numofbrackets+1

       If pos('}',temp) <> 0 then         /* decrease count for close */
         numofbrackets= numofbrackets-1

    End/* End do*/

    'MARK LINE'                        /* We found the closing bracket */
return                                 /* so mark the line.            */
