/******************************************************************/
/* Enter today's date in a variety of formats.                    */
/*                                                                */
/* - If arg is a single letter & a valid arg to the REXX date()   */
/*   function then enter date in that format.                     */
/* - If arg is an abbreviation of Iso then use ccyy-mm-dd form    */
/* - If arg is an abbreviation of SHort use PM national setting   */
/* - If arg is an abbreviation of LOng use PM national setting    */
/*   to work out a suitable long format                           */
/* - If arg is an abbreviation of FUll use PM national setting    */
/*   to work out a suitable long format, and put the English      */
/*   day name in front                                            */
/*                                                                */
/*   Short is the default form                                    */
/*                                    Toby Thurston - 19 Nov 1997 */
/******************************************************************/
arg ?
'cursor data'
select
  when length(?) = 1 & pos(?,"BDELMNOSUW") > 0 then 'keyin' date(?)
  when abbrev("ISO",?,1) then 'keyin' insert("-",insert("-",date(s),6),4)
otherwise
  call findsettings  /* <-- this subroutine works on OS/2 PM only */
  select
    when abbrev("LONG",?,2) then 'keyin' longdate()
    when abbrev("FULL",?,2) then 'keyin' fulldate()
  otherwise
    'keyin' shortdate()
  end
end
exit

findsettings: procedure expose iDate sDate
  call RxFuncAdd 'SysIni', 'RexxUtil', 'SysIni'
  iDate = strip(SysIni(,'PM_National','iDate'),'T',d2c(0))     /* 0 = mdy, 1 = dmy, 2 = ymd */
  sDate = strip(SysIni(,'PM_National','sDate'),'T',d2c(0))     /* sep char */
  if iDate = '' | iDate = 'ERROR:' then iDate = 0
  if sDate = '' | sDate = 'ERROR:' then sDate = '/'
return

shortdate: procedure expose iDate sDate
  parse value date("s") with y +4 m +2 d +2
  select
    when iDate = 1 then return d""sDate""m""sDate""y
    when iDate = 2 then return y""sDate""m""sDate""d
  otherwise              /* should only be 0 but catch everything */
    return m""sDate""d""sDate""y
  end

longdate: procedure expose iDate sDate
  parse value date("L") with d m y
  select
    when iDate = 1 then return d m y
    when iDate = 2 then return y m d
  otherwise              /* should only be 0 but catch everything */
    return m d"," y
  end

fulldate: procedure expose iDate sDate
  parse value date("W") date("L") with w d m y
  select
    when iDate = 1 then return w d m y
    when iDate = 2 then return y m d w
  otherwise              /* should only be 0 but catch everything */
    return w"," m d"," y
  end

