/***************************************************************************/
/*                                                                         */
/* Create a popup window to select and enter an OS/2 INCL definition into  */
/* the current file.  The selected text is inserted after the current      */
/* line.                                                                   */
/*                                                                         */
/* We do a quick check for inclusion of os2.h, and add the line if we      */
/* can't find it.                                                          */
/*                                                                         */
/* Useful when assigned to a syntax expansion macro (in version 1.67 and   */
/* above):                                                                 */
/*                                                                         */
/*   expand_keyword     = defos2                                           */
/*   expand_macro       = "defos2"                                         */
/*                                                                         */
/* Written by B. Thompson, September 22, 1995                              */
/* Updated January 20, 1996 for version 1.72, to input a new line          */
/*                                                                         */
/***************************************************************************/

  'EXTRACT /CURSOR/'                               /* Remember where we are*/
  curline = cursor.1
  'L /#include <os2.h>'
  If rc = 0
    Then Do                       /* Make sure we're above the include line*/
      'EXTRACT /CURSOR/'
      If cursor.1 < curline
        Then Do                      /* Insert a temp line above os2.h line*/
          'CURSOR' curline                           /* Restore line number*/
          'DELETE'
          'CURSOR' cursor.1 - 1                    /* Just above os2.h line*/
          'INPUT'
          curline = cursor.1                            /* New current line*/
        End
    End
    Else 'INPUT #include <os2.h>'

  'RESTORE_FIND'                            /* Restore previous find target*/
  'CURSOR' curline                                   /* Restore line number*/
  'REFRESH'                                          /* Show changed screen*/

  'WINDOW 14 40 42 OS/2 Include Definitions'

  'WINLINE DOSDATETIME     \nINPUT #define  INCL_DOSDATETIME /* Date and time information*/'
  'WINLINE DOSERRORS       \nINPUT #define  INCL_DOSERRORS /* Error definitions*/'
  'WINLINE DOSEXCEPTIONS   \nINPUT #define  INCL_DOSEXCEPTIONS /* Exception handling*/'
  'WINLINE DOSFILEMGR      \nINPUT #define  INCL_DOSFILEMGR /* File management APIs*/'
  'WINLINE DOSMEMMGR       \nINPUT #define  INCL_DOSMEMMGR /* Memory management*/'
  'WINLINE DOSMISC         \nINPUT #define  INCL_DOSMISC /* System info*/'
  'WINLINE DOSMODULEMGR    \nINPUT #define  INCL_DOSMODULEMGR /* Modules and DLLs*/'
  'WINLINE DOSNLS          \nINPUT #define  INCL_DOSNLS /* Country specific stuff*/'
  'WINLINE DOSPROCESS      \nINPUT #define  INCL_DOSPROCESS /* Process Control*/'
  'WINLINE DOSSEMAPHORES   \nINPUT #define  INCL_DOSSEMAPHORES /* Semaphore support*/'
  'WINLINE DOSSESMGR       \nINPUT #define  INCL_DOSSESMGR /* Session Manager values*/'
  'WINLINE GPIBITMAPS      \nINPUT #define  INCL_GPIBITMAPS /* Bitmaps*/'
  'WINLINE GPICONTROL      \nINPUT #define  INCL_GPICONTROL /* Presentation space manipulation*/'
  'WINLINE GPIERRORS       \nINPUT #define  INCL_GPIERRORS /* GPI error codes*/'
  'WINLINE GPILCIDS        \nINPUT #define  INCL_GPILCIDS /* FontMetrics definitions*/'
  'WINLINE GPIPRIMITIVES   \nINPUT #define  INCL_GPIPRIMITIVES /* Basic graphics functions*/'
  'WINLINE KBD             \nINPUT #define  INCL_KBD /* Keyboard interfaces*/'
  'WINLINE MOU             \nINPUT #define  INCL_MOU /* Mouse support*/'
  "WINLINE NOCOMMON        \nINPUT #define  INCL_NOCOMMON /* Don't give me anything by default*/"
  'WINLINE SHLERRORS       \nINPUT #define  INCL_SHLERRORS /* Shell error handling*/'
  'WINLINE VIO             \nINPUT #define  INCL_VIO /* Video input/output*/'
  'WINLINE WINACCELERATORS \nINPUT #define  INCL_WINACCELERATORS /* Key accelerators*/'
  'WINLINE WINBUTTONS      \nINPUT #define  INCL_WINBUTTONS /* Pushbutton control*/'
  'WINLINE WINCLIPBOARD    \nINPUT #define  INCL_WINCLIPBOARD /* Clipboard access*/'
  'WINLINE WINDIALOGS      \nINPUT #define  INCL_WINDIALOGS /* Dialog boxes*/'
  'WINLINE WINENTRYFIELDS  \nINPUT #define  INCL_WINENTRYFIELDS /* Entry field controls*/'
  'WINLINE WINERRORS       \nINPUT #define  INCL_WINERRORS /* Error handling routines*/'
  'WINLINE WINFRAMEMGR     \nINPUT #define  INCL_WINFRAMEMGR /* Frame and menu manager*/'
  'WINLINE WINHELP         \nINPUT #define  INCL_WINHELP /* IPF help manager*/'
  'WINLINE WININPUT        \nINPUT #define  INCL_WININPUT /* Keyboard entry and window focus*/'
  'WINLINE WINLISTBOXES    \nINPUT #define  INCL_WINLISTBOXES /* Listbox controls*/'
  'WINLINE WINMENUS        \nINPUT #define  INCL_WINMENUS /* Menus and ownerdraw listboxes*/'
  'WINLINE WINMESSAGEMGR   \nINPUT #define  INCL_WINMESSAGEMGR /* Pointer & window messages*/'
  'WINLINE WINMLE          \nINPUT #define  INCL_WINMLE /* Multi-line edit controls*/'
  'WINLINE WINPOINTERS     \nINPUT #define  INCL_WINPOINTERS /* Icon pointer definitions*/'
  'WINLINE WINSTATICS      \nINPUT #define  INCL_WINSTATICS /* Static text controls*/'
  'WINLINE WINSTDBOOK      \nINPUT #define  INCL_WINSTDBOOK /* Notebook control class*/'
  'WINLINE WINSTDCNR       \nINPUT #define  INCL_WINSTDCNR /* Container control class*/'
  'WINLINE WINSTDFONT      \nINPUT #define  INCL_WINSTDFONT /* Font dialog*/'
  'WINLINE WINSWITCHLIST   \nINPUT #define  INCL_WINSWITCHLIST /* Switch list entries*/'
  'WINLINE WINSYS          \nINPUT #define  INCL_WINSYS /* System defaults*/'
  'WINLINE WINTIMER        \nINPUT #define  INCL_WINTIMER /* Timer processing messages*/'
  'WINLINE WINWINDOWMGR    \nINPUT #define  INCL_WINWINDOWMGR /* General window management*/'

Exit
