/***************************************************************************/
/*                                                                         */
/* FAVS.X - Manage a list of "favorite" files.                             */
/*                                                                         */
/* Do you frequently find yourself editing the same files?  If you're      */
/* tired of typing the same filenames over and over again, try this macro. */
/* It allows you to maintain a list of your favorite files, and select the */
/* one to edit from a popup window.                                        */
/*                                                                         */
/* Invocation:  FAVS <ADD|DELETE> <Filename>                               */
/*                                                                         */
/*   -  If called with no parameters, the current list of files is         */
/*      displayed in a popup window for selection.                         */
/*   -  If called with the ADD parameter, the supplied Filename is added   */
/*      to the list.  If Filename is not supplied, the name of the         */
/*      currently active file is used.                                     */
/*   -  If called with the DELETE parameter, the supplied Filename is      */
/*      removed from the list.  If Filename is not supplied, the name of   */
/*      the currently active file is used.                                 */
/*                                                                         */
/* This program is self-modifying!!  It will not work correctly if placed  */
/* on a read only drive, or if the file itself is made read only.          */
/*                                                                         */
/* Written by Blair Thompson, March 21, 1996                               */
/*                                                                         */
/***************************************************************************/


/***************************************************************************/
/*                                                                         */
/* The following variable contains the list of files.  This must be the    */
/* first occurrence of this variable name found in the file.  This line    */
/* will be changed in response to the ADD and DELETE operands.             */
/*                                                                         */
/***************************************************************************/

  fav_list = "xdef.lst C:\cseb\INCLUDE\CSEBDEF.H C:\IBMCPPW\INCLUDE\ISTRING.HPP C:\cseb\INCLUDE\CSEBCPP.H C:\blair\toolbox\makefile.hdr C:\IBMCPPW\SDK\WINH\WINCON.H C:\IBMCPPW\SDK\WINH\WINUSER.H C:\IBMCPPW\SDK\WINH\CommCtrl.h"

  Parse Source os invoke sourcefn .
  Parse Arg op fn .
  op = Translate(op)

  If op = '?'
    Then Do                                                 /* Provide help*/
      'MSG Arguments are ADD | DELETE'
      Exit
    End                                                           /* End do*/

  If Wordpos(op, 'ADD DELETE') = 0
    Then Do                                             /* Display the list*/
      If fav_list = ""
        Then Do
          'MSG Favorite list is empty!'
          Exit 99
        End

      'WINDOW 10 50' Words(fav_list) 'Favorite Files'
      Do While fav_list <> ""
        Parse Var fav_list fn fav_list
        winfn = fn
        index = Pos('\',winfn)
        Do While index > 0
          winfn = Substr(winfn,1,index)'\'Substr(winfn,index+1)
          index = Pos('\',winfn,index+2)
        End
        'WINLINE' winfn'\nEDIT' fn
      End                                                         /* End do*/
      Exit
    End

  If fn = ''
    Then Do                          /* We need to get the current filename*/
      'EXTRACT /NAME/'
      fn = name.1
    End

  'EDIT' sourcefn '/TOP /Q'
  'L /fav_list/'
  l_rc = rc
  'RESTORE_FIND'
  If l_rc <> 0
    Then Do
      'MSG Error editing' sourcefn': favorites list not found'
      Exit 98
    End

  'EXTRACT /CURLINE/'
  Parse var curline.1 prefix '"' list '"'
  If op = 'ADD'
    Then Do
      list = list fn
      msg = fn 'added to favorites list'
    End
    Else Do                                             /* Delete the entry*/
      uplist = Translate(list)
      index = Wordpos(translate(fn), uplist)
      If index > 0
        Then Do                                         /* We can delete it*/
          list = Delword(list,index,1)
          msg = fn 'removed from favorites list'
        End
        Else Do                              /* No need to update the macro*/
          'QQUIT'
          'MSG' fn 'not found in current favorites list'
          Exit
        End
    End

  'REPLACE' prefix'"'list'"'
  'FILE'
  If rc <> 0
    Then msg = 'Error saving changes in macro'

  'MSG' msg
Exit
