/***************************************************************************/
/* FILLBLCK.X                                                              */
/*                                                                         */
/* X2 macro to fill a block marked area with a rectangular pattern defined */
/* by the cursor position and the upper left corner mark.                  */
/*                                                                         */
/* Written by Wing F. Yuen (WFY316 at PKMFGVM1) on 07/27/95                */
/***************************************************************************/

c = 'COMMAND'
c 'EXTRACT /MARK/'

/* ----- Do we have a block marked area? ----- */
If MARK.0 = 0
  Then Do
    c 'MSG No marked area!'
    Exit
  End

If MARK.6 = 0
  Then Do
    c 'MSG The current file is not marked!'
    Exit
  End

If MARK.4 = 0 & MARK.5 = 0
  Then Do
    c 'MSG Cannot fill line marks!'
    Exit
  End

Area.left   = MARK.4
Area.right  = MARK.5
Area.top    = MARK.2
Area.bottom = MARK.3

/* ----- Is the cursor inside the marked area? ----- */
c 'EXTRACT /CURSOR/'
If CURSOR.1 < Area.top  | CURSOR.1 > Area.bottom | ,
   CURSOR.2 < Area.left | CURSOR.2 > Area.right
  Then Do
    c 'MSG Cursor outside marked area!'
    Exit
  End

Pattern.bottom = CURSOR.1
Pattern.right  = CURSOR.2

AreaWidth = Area.right - Area.left + 1
AreaDepth = Area.bottom - Area.top + 1
PatternWidth = Pattern.right - Area.left + 1
PatternDepth = Pattern.bottom - Area.top + 1

PatternRow = PatternDepth
Do FileRow = Area.top to Pattern.bottom
  c 'EXTRACT /CURLINE/'
  Template = substr( CURLINE.1, Area.left, PatternWidth)
  Copies = AreaWidth % PatternWidth
  Tail = left( Template, AreaWidth - (PatternWidth * Copies))
  Pattern.PatternRow = ''
  Do while Copies > 0
    Pattern.PatternRow = Pattern.PatternRow||Template
    Copies = Copies - 1
  End                                                             /* End do*/
  Pattern.PatternRow = Pattern.PatternRow||Tail
  c 'UP'
  PatternRow = PatternRow - 1
End                                                               /* End do*/

/* ----- cursor is now one row above the marked area ----- */
j = 1
Do i = 1 to AreaDepth
  c 'DOWN'
  c 'EXTRACT /CURLINE/'
  c 'REPLACE' overlay( Pattern.j, curline.1, Area.left)
  If j = PatternDepth
    Then j = 1                                   /* cycles the pattern rows*/
    Else j = j + 1
End                                                               /* End do*/

/* ----- restore cursor position ----- */
c 'CURSOR' Pattern.bottom Pattern.right
c 'REFRESH'

Exit
