/***************************************************************************/
/*                                                                         */
/* Find all files in the ring which contain the given string.  All other   */
/* files are removed from the ring, unless they have been modified.        */
/*                                                                         */
/* Written by B. Thompson, November 8, 1993                                */
/* Start search from line 0 in case it's on line 1, February 2, 1998       */
/*                                                                         */
/***************************************************************************/

  Parse Arg searchstring
  If searchstring <> ''
    Then 'L' searchstring                            /* Set the find target*/

  'EXTRACT /NAME/'
  startdoc = name.1
  'MSG Searching...'
  done = 0
  docsfound = 0
  Do While \done
    'NEXT'
    'EXTRACT /NAME/'
    If name.1 = startdoc
      Then Do                                     /* We've come full circle*/
        done = 1
        If docsfound = 0
          Then Leave                          /* Leave one file in the ring*/
      End

    'MSG Searching' name.1'...'
    'TOP'
    'UP'
    'REPFIND'
    If rc = 0
      Then docsfound = docsfound + 1
      Else Do                         /* Remove file from ring if unchanged*/
        'EXTRACT /ALT/'
        If alt.2 = 0
          Then 'QQUIT'
      End
  End                                                             /* End do*/

  If docsfound > 0
    Then 'MSG String found in' docsfound 'file(s)'
    Else 'MSG String not found in ring; current file not searched'

Exit
