/***************************************************************************/
/*                                                                         */
/* Create a list of all the C functions in the current file, and input it  */
/* at the current cursor position.  We identify a C function by looking    */
/* for an open brace in column 1 of the file, then scanning back through   */
/* 10 lines for a line with an open parenthesis on it.                     */
/*                                                                         */
/* Written by B. Thompson, January 30, 1995                                */
/*                                                                         */
/***************************************************************************/

  'EXTRACT /CURSOR/'                           /* Remember where we started*/
  origline = cursor.1
  'BOTTOM'
  'CURSOR +0 1'                                                 /* Column 1*/
  'MARK CLEAR'
  'MARK BLOCK'                                            /* Start the mark*/
  'TOP'
  'MARK BLOCK'                                         /* Complete the mark*/
  lastline = 1
  funcnum = 0

  'L /{/ M'                                        /* Find first occurrence*/
  Do While rc = 0
    'EXTRACT /CURSOR/'
    If cursor.1 <= lastline
      Then Leave                                              /* We wrapped*/
    lastline = cursor.1
    'UP 1'
    'EXTRACT /CURLINE/'
    funcnum = funcnum + 1
    func.funcnum = curline.1
    'REPFIND'
    'REPFIND'                                       /* Find next occurrence*/
  End                                                             /* End do*/

  'MARK CLEAR'
  'CURSOR' origline
  Do innum = 1 to funcnum                              /* Input the results*/
    'INPUT' func.innum
  End                                                             /* End do*/

Exit
