/***************************************************************************/
/*                                                                         */
/* HILITE.X                                                                */
/*                                                                         */
/* Highlight all occurrences of the supplied string with the supplied      */
/* colour.  For example "hilite red on black /if/ e".  The highlighting    */
/* colour must be supplied first in case options are required on the find  */
/* string, but may be specified as "clear" to clear all previous           */
/* highlighting.  Note that all previous highlighting on a line is removed */
/* by this macro if the find string is located on that line.               */
/*                                                                         */
/* Only visible lines are affected by this macro.                                                                        */
/*                                                                         */
/* Written by Blair Thompson, September 17, 2001                           */
/*                                                                         */
/***************************************************************************/

  Parse Arg fg on_kw bg findstring
  If Translate(fg) = 'CLEAR'
    Then Do
      clear = 1
      Parse Arg . findstring
    End                                                           /* End do*/
    Else Do
      clear = 0
      highlight_colour = fg on_kw bg
    End

  If findstring = ''
    Then Do
      'MSG Parms: [CLEAR | fg ON BG] /String/'
      Exit
    End                                                           /* End do*/

  'extract /msgmode/'                              /* Save current settings*/
  'extract /wrap/'
  'extract /cursor/'
  spos = cursor.1 cursor.2
  'wrap off'
  'msgmode off'

  '0'
  'locate' findstring
  'extract /find/'
  find_len = Length(find.1) - 3
  '0'
  'repeat_find'
  Do While rc = 0
    If clear
      Then lc_cmd = ''
      Else Do
        'extract /cursor/'
        lc_cmd = cursor.2 cursor.2 + find_len highlight_colour
      End
    'linecolour' lc_cmd

    'repeat_find'
  End                                                             /* End do*/

  'wrap' wrap.1                                                  /* Restore*/
  'cursor' cursor.1 cursor.2
  'msgmode' msgmode.1
Exit
