/**********************************************************************/
/* This is a macro to edit Script files imbedded into a master doc    */
/* You put the cursor on a line that says ".im thisfile" run this     */
/* macro, and it edits thisfile.scr in the same directory as the      */
/* current file.  Also supports host files: for VM it will look for   */
/* hx:thisfile script; for MVS it will look for a member called       */
/* thisfile in the same PDS as your current member                    */
/*                                                                    */
/* If the line does not start with .im or .setup then it calls the    */
/* standard OPENFILE function (like ctrl-P)                           */
/*                                                                    */
/* This macro is suitable for remapping to the Ctrl-P key (when this  */
/* is available) (R1.60?)                                             */
/*                                                                    */
/* Toby Thurston 1994-1995                                            */
/**********************************************************************/
'command extract /curline/'
imbedwords = ".IM .SETUP"
if wordpos(translate(word(curline.1,1)),imbedwords) > 0 then do
  imbed = word(curline.1,2)
  'command extract /name/'
  name = translate(name.1)
  if left(name,1) = "H" & substr(name,3,1) = ":"  then do /* host file*/
    if words(name) > 1 then do                              /* VM file*/
      parse var name left ":" . ft fm
      'edit' left || ":" || imbed ft fm
    end
    else do                            /* MVS file -- assume PDSs only*/
      parse var name left "(" . ")" right
      'edit' left || "(" || imbed || ")" || right
    end
  end
  else do                                                   /* pc file*/
    x = lastpos("\",name)
    'edit' substr(name,1,x) || imbed || ".scr"
  end
end
else 'openfile'
