/***************************************************************************/
/*                                                                         */
/* Display a popup window of all the #include lines found in the current   */
/* file.  When a line is selected, open that include line.                 */
/*                                                                         */
/* Written by Blair Thompson, February 27, 1996                            */
/* Support makefile include format, use WINWAIT, January 13, 2000          */
/*                                                                         */
/***************************************************************************/

  Parse Source . . macroname '.' .                           /* Who are we?*/

  'EXTRACT /MSGMODE/'
  'MSGMODE OFF'
  'EXTRACT /CURSOR/'                               /* Remember where we are*/
  myrow = cursor.1
  mycol = cursor.2
  'EXTRACT /ESCAPE/'

  'EXTRACT /WRAP/'
  'WRAP OFF'
  'TOP'
  'EXTRACT /FT/'
  If ft.1 = 'MAK'                              /* Look for 1st include line*/
    Then 'L /!include/ Q'                                /* Makefile format*/
    Else 'L /#include/ E'                              /* Default, C format*/
  num_includes = 0
  Do While rc = 0                                 /* Find all include lines*/
    'EXTRACT /CURLINE/'
    'EXTRACT /CURSOR/'
    num_includes = num_includes + 1
    inc.num_includes = curline.1
    line.num_includes = cursor.1
    'REPFIND'
  End                                                             /* End Do*/

  'WINDOW' min(num_includes,10) 50 num_includes 'Included Header Files'
  Do i = 1 to num_includes
    Parse Var inc.i pre fn post
    fn = Substr(fn,1,1) || escape.1'S'Substr(fn,2)
    'WINLINE' pre fn post'\nSETRESULT' line.i
  End                                                             /* End Do*/

  'RESTORE_FIND'
  'WRAP' wrap.1
  'CURSOR' myrow mycol                                  /* Restore location*/
  'MSGMODE' msgmode.1

  If num_includes = 0
    Then Do
      'MSG No #include lines found in current file'
      Exit
    End                                                           /* End do*/

  'WINWAIT'                                           /* Display the window*/
  If rc = 0
    Then Do                                       /* Something was selected*/
      targline = result
      'EXTRACT /FILENAME/'
      sourcename = filename.1
      'CURSOR' targline
      'OPENFILE'                                   /* Open the include file*/
      'EXTRACT /FILENAME/'
      'EDIT' sourcename                              /* Back to source file*/
      'CURSOR' myrow mycol                            /* Restore the cursor*/
      'EDIT' filename.1                             /* Back to include file*/
    End                                                           /* End do*/
Exit
