/***************************************************************************/
/*									   */
/* Look up a keyword in an INF file.  Looks for the first word on the      */
/* current line, starting at the cursor position.  Displays the PM Help    */
/* screen associated with the keyword.  Based on the KWHELP.E file in EPM. */
/*									   */
/* To use this macro, the HELPNDX environment variable must be defined to  */
/* point to all the index file(s) you wish to use, e.g.			   */
/*									   */
/*   SET HELPNDX=EPMKWHLP.NDX+DDE4UIL.NDX+DDE4CCL.NDX+DDE4CLIB.NDX	   */
/*									   */
/* The .NDX files in the HELPNDX path must all be found somewhere along    */
/* the path defined by the BOOKSHELF environment variable.		   */
/*									   */
/* Format of index file:						   */
/*   (Win*, view winhelp.inf ~)						   */
/*   (printf, view edchelp.inf printf)					   */
/*									   */
/* This macro is most useful when defined to a key.  I use c-F1.	   */
/*									   */
/* Requires X.EXE version 1.29 or later					   */
/* Written by B. Thompson, January 18, 1994				   */
/* Add check for single * wildcard, September 19, 1994			   */
/* Use X to load NDX files for improved performance, March 13, 1996	   */
/* If in X helpfile, look up keyword in X.INF directly, April 29, 1996     */
/* Remove pointer characters, February 3, 1997				   */
/*									   */
/***************************************************************************/

  'EXTRACT /CURLINE/'
  'EXTRACT /CURSOR/'
  cmd = Substr(curline.1,cursor.2)
  cmd = Word(cmd,1)				    /* Only take first word*/
  Parse Upper Var cmd cmd '(' .		  /* Remove any possible parameters*/
  Parse Upper Var cmd cmd '&' .
  Parse Upper Var cmd cmd '*' .
  Parse Upper Var cmd cmd ',' .
  Parse Upper Var cmd cmd ':' .
  Parse Upper Var cmd cmd '<' .
  If cmd = ''
    Then Do
      'MSG No function found'
      Exit
    End

  'EXTRACT /NAME/'
  'EXTRACT /HELPFILE/'
  If name.1 = helpfile.1
    Then Do
      Address CMD 'VIEW X' cmd
      Exit
    End

  Call rxfuncadd 'SysSearchPath', 'RexxUtil', 'SysSearchPath'

  helpndx = Value('HELPNDX',,'OS2ENVIRONMENT')
  If helpndx = ''
    Then helpndx = 'EPMKWHLP.NDX'

  got_cmd = 0
  'EXTRACT /MSGMODE/'
  'MSGMODE OFF'
  Do While helpndx <> ''			    /* Scan each help index*/
    Parse Var helpndx ndx '+' helpndx
    file = SysSearchPath('BOOKSHELF',ndx)
    If file <> ''				     /* File found, read it*/
      Then Do
	'EDIT' file '/TOP'
	'MSGMODE ON'
	'MSG Searching' file'...'
	'MSGMODE OFF'
	'L /'cmd'/ c'
	l_rc = rc
	'RESTORE_FIND'
	If l_rc <> 0
	  Then Do
	    'ALL /(/ & /*,/'				   /* Faster search*/
	    Do len = Length(cmd) to 2 by -1 While l_rc <> 0
	      'L /'Substr(cmd,1,len)'*/ c'
	      l_rc = rc
	      'RESTORE_FIND'
	    End						    /* End do while*/
	  End
	If l_rc = 0
	  Then Do
	    'EXTRACT /CURLINE/'
	    Parse Var curline.1 '(' prefix ',' view_cmd ')'
	    If view_cmd <> ''
	      Then got_cmd = 1
	  End							  /* End do*/
	'QQUIT'					     /* Done with this file*/
      End
    If got_cmd
      Then Leave
  End								  /* End do*/

  'MSGMODE' msgmode.1
  If got_cmd = 0
    Then Do
      'MSG Unable to find' cmd 'in index file(s)'
      Exit
    End

  Do Forever			      /* Translate ~ to original identifier*/
    tilde = Pos('~',view_cmd)
    If tilde = 0
      Then Leave						    /* Done*/
    view_cmd = Substr(view_cmd,1,tilde-1) || cmd ,
      || Substr(view_cmd,tilde+1)
  End								  /* End do*/

  Address CMD view_cmd					      /* Execute it*/
  'MSG' cmd 'found in index file' file
Exit
