/***************************************************************************/
/*                                                                         */
/* MAK.X                                                                   */
/*                                                                         */
/* Generate the dependencies list for the given source file.               */
/*                                                                         */
/* This macro may be called from the editor command line, or as a syntax   */
/* expansion macro with the following lines in the profile definition      */
/* file (requires version 1.77 for expand_macro invocation):               */
/*                                                                         */
/*   extension          = MAK                                              */
/*   expand_keyword     = "mak \1"                                         */
/*   expand_macro       = "mak \1"                                         */
/*                                                                         */
/* I prefer to maintain separate object files for optimised and debug      */
/* versions.  I do this by way of an OBJ variable.  If you prefer to keep  */
/* all your object files with extension obj, change $(OBJ) into obj in     */
/* this file.                                                              */
/*                                                                         */
/* Written by Blair Thompson, May 13, 1996                                 */
/* Extend output length if input filename is very long, September 2, 1996  */
/* Use output extension .RES For .RC files, February 11, 1997              */
/* Add check For modified files in the ring, March 21, 1997                */
/* Start at line 0 instead of TOF, November 30, 1998                       */
/*                                                                         */
/***************************************************************************/

  Parse Arg file .
  If file = ''
    Then Do
      'MSG A filename must be supplied to this function'
      Exit
    End

  Parse Var file fn '.' ext
  'EXTRACT /FILENAME/'
  makefile = filename.1

  'EXTRACT /RING/'
  Do While words(ring.1) > 1
    'NEXT'
    'EXTRACT /ALT/'
    If alt.2 <> 0
      Then Do
        'File is modified.  Save it before running this macro'
        Exit
      End
    'EXTRACT /FILENAME/'
    If filename.1 = makefile
      Then Leave                                /* We've completed the loop*/
    'EXTRACT /RING/'
  End                                                             /* End do*/

  files = file
  ft = PROCESS_FILE(file)

  'X' makefile                          /* Make sure we have the right file*/
  If ft = 'RC'
    Then prefix = fn'.RES:'
    Else prefix = fn'.$(OBJ):'
  Do While files <> ""
    Parse Var files file files
    If Length(prefix) < 16
      Then prefix = Left(prefix,16)
    'INPUT' prefix file '\'
    If prefix <> ''
      Then Do
        prefix = ''
        'EXTRACT /CURSOR/'                         /* Remember where we are*/
        csr_start = cursor.1 + 1
      End
  End                                                             /* End do*/
  'EXTRACT /CURSOR/'                             /* Remember final position*/
  csr_end = cursor.1
  If csr_end > csr_start
    Then Do                                         /* Multiple lines added*/
      'MARK CLEAR'
      'MARK LINE'
      'CURSOR' csr_start
      'MARK LINE'
      'SORT'                                     /* Sort 'em alphabetically*/
    End
  'CURSOR' csr_end
  'EXTRACT /CURLINE/'
  newline = Substr(curline.1,1,length(curline.1)-1)/* Remove trailing bslash*/
  'REPLACE' newline
Exit

PROCESS_FILE:  Procedure Expose files
  Parse Arg file .
  'X' file '/Q'
  'EXTRACT /FT/'
  'WRAP OFF'
  '0'
  newfiles = ''
  'L /#include/ E'                             /* Look for 1st include line*/
  Do While rc = 0                                 /* Find all include lines*/
    'EXTRACT /CURLINE/'
    Parse Var curline.1 pref '#include' file .
    If pref = '' & Substr(file,1,1) = '"'
      Then Do                                     /* Local include, scan it*/
        file = Substr(file,2,Length(file)-2)
        If Wordpos(file,files) = 0
          Then newfiles = newfiles file
      End
    'REPFIND'
  End                                                             /* End Do*/

  'RESTORE_FIND'
  'QQUIT'                                              /* Back to base file*/
  files = files newfiles
  Do While newfiles <> ""
    Parse Var newfiles file newfiles
    Call PROCESS_FILE(file)
  End                                                             /* End do*/
Return ft.1
