/***************************************************************************/
/*									   */
/* READFILE.X								   */
/*									   */
/* Enter skeleton code for reading a file in a loop.  We support C and     */
/* REXX format.								   */
/*									   */
/* Written by Blair Thompson, October 14, 1996				   */
/*									   */
/***************************************************************************/

  'EXTRACT /FT/'
  ft.1 = Translate(ft.1)
  Select
    When Wordpos(ft.1,'C CPV CPP') > 0
      Then Call c_fmt
    When WordPos(ft.1,'CMD X') > 0
      Then Call rexx_fmt
    Otherwise
      'MSG Unrecognised file extension'
  End							      /* End select*/
Exit


/***************************************************************************/
/*									   */
/* Input the C code necessary to read each line.  We're limited to 160     */
/* byte lines, and the input filename must be added in.			   */
/*									   */
/***************************************************************************/

C_FMT:  Procedure
  'INPUT typedef FILE *PFILE;      /* Ptr to disk file stream */'
  'INPUT   PFILE    pfIn = NULL;   /* Input file handle*/'
  'INPUT   CHAR     szInLine[161]; /* Input buffer*/'
  'INPUT   PSZ      pszInFile;     /* Ptr to input filename*/'
  'INPUT   INT      iRc;           /* Function return code*/'
  'INPUT'
  'INPUT   pfIn = fopen(pszInFile, "r");'
  'INPUT   if (pfIn == NULL)'
  'INPUT     {'
  'INPUT       printf("Error opening input file %s\n", pszInFile);'
  'INPUT       return -1;'
  'INPUT     }                     /* End if*/'
  'INPUT'
  'INPUT   while (!feof(pfIn))'
  'INPUT     {'
  'INPUT       iRc = fscanf(pfIn, "%160[^\n]%*c", szInLine);'
  'INPUT       if (iRc == EOF)'
  'INPUT         break;'
  'INPUT       if (!iRc)'
  'INPUT         {'
  'INPUT           fscanf(fileInStream, "%*c");  /* Skip blank line*/'
  'INPUT           continue;'
  'INPUT         } /* End if */'
  'INPUT'
  'INPUT       /* Process the line */'
  'INPUT     }                 /* End while*/'
  'INPUT   fclose(pfIn);'
Return


/***************************************************************************/
/*									   */
/* Input the REXX code necessary to read each line.			   */
/*									   */
/***************************************************************************/

REXX_FMT:  Procedure
  "INPUT   infile = 'xxxxx.xxx'"
  "INPUT   Do While Lines(infile)"
  "INPUT     iline = Linein(infile)"
  "INPUT   End"
  "INPUT"
  "INPUT   Call stream infile,'C','CLOSE'"
Return
