/* ---rgf, 2000-05-18; 2000-06-08 10:07pm
   on OS/2 and Windows NT make sure, that the editor starts with at least
      125 columns ("minCols") and 45 lines ("minLines");

   on Win95 use 80cols and 43rows as minimum as it won't allow other than
      80cols and only 24, 43 an 50 rows; assume same for Win98;

   remembers old screen size and restores it on exit

   using the process' environment to store the restore-command, if necessary

   bug in Win95? - mode-change not recognized by xwnt.exe on first time,
                   hence re-issuing it
*/

if arg(1) = "STOP" then         /* "exit" of x2, last chance to do something meaningful ... ;)  */
do
   restore = value("RESTORE.CMD",,"ENVIRONMENT")/* try to get possible restore screen-size cmd  */
   if restore <> "" then        /* if restore command available, execute it                     */
   do
      'SHELL' restore           /* shell out ;) the saved restore-command!                      */
       call value "RESTORE.CMD","", "ENVIRONMENT"       /* set to blank                         */
   end
   exit
end

'EXTRACT /OS/'                  /* get operating system version from editor                     */
os = changestr(' ',translate(os.1),'')  /* translate to uppercase, remove blanks                */
idx = wordpos(os, 'OS/2 WINDOWSNT WINDOWS95 WINDOWS98') /* known op-sys                         */

Select                          /* define minimum number of columns and lines                   */
  When idx = 1 | idx = 2 then   /* os/2 and windows nt                                          */
       Do
          minCols=125
          minLines=45
       End

  When idx = 3 | idx = 4 | ABBREV(os, "WIN")  then/* win95, win98; and any newer Windows-version*/
       Do
          minCols= 80
          minLines=43           /* 25, 43 or 50                                                 */
       End

  Otherwise exit                /* unsupported op-sys                                           */
End

if value("RESTORE.CMD",,"ENVIRONMENT") = "" then/* no restore-command, first invocation, maybe change window-size*/
do
   PARSE VALUE SysTextScreenSize() WITH lines cols      /* get as-is screen dimensions          */

   if (minLines > lines) | (minCols > cols) then/* screen size change necessary?                */
   do
                /* prepare restore command      */
      if idx = 1 /* OS/2 */ then command = "mode co"        || cols ||","    || lines
                            else command = "mode con cols=" || cols "lines=" || lines

      call value "RESTORE.CMD",command,"ENVIRONMENT"

                /* change screen size           */
      lines = max(minLines, lines);     /* determine number of lines                            */
      cols  = max(minCols, cols)/* determine number of columns                                  */
      if idx = 1 /* "OS/2" */ then command = "mode co"        || cols ||","    || lines
                              else command = "mode con cols=" || cols "lines=" || lines

      'SHELL' command           /* execute command in shell                                     */
      if idx=3 /* Win95 */ then 'SHELL' command  /* on Win95 repeat it, so xwnt.exe recognizes screen change*/
   end
end

