/***************************************************************************/
/*                                                                         */
/* RINGCMD - Execute a command on all files in the ring                    */
/*           Show rc and LASTMSG from command with filename in a window    */
/*                                                                         */
/* Works on Windows/NT with Regina                                         */
/*                                                                         */
/* Written  by Morten Kjrulff 20000106                                    */
/* Modified by Morten Kjrulff 20000107 Added REFRESH command              */
/* Modified by Morten Kjrulff 20000110 Added LASTMSG to display           */
/*                                                                         */
/***************************************************************************/

  parse arg arg

  if arg = '' then do
    'PROMPT Enter command to execute on all files in the ring'
    if rc <> 0 then exit
    arg = result
  end

  'EXTRACT /RING/'

  length_rc=0
  length_msg=0
  length_ring=0

  do i=1 to ring.0

    'MSG .'

    ''arg

    rc.i = rc
    if length(rc.i) > length_rc then length_rc = length(rc.i)

    'EXTRACT /LASTMSG/'
    msg.i = lastmsg.1
    if length(msg.i) > length_msg then length_msg = length(msg.i)

    if length(ring.i) > length_ring then length_ring = length(ring.i)

    'NEXT'
    'REFRESH'

  end

  'WINDOW' ring.0 length_rc+1+length_msg+1+length_ring ring.0 arg

  do i=1 to ring.0
    'WINLINE' right(rc.i,length_rc) left(msg.i,length_msg) ring.i '\n X' ring.i
  end

  exit
