/* REXX
  Written by Marc Remes, May 18, 1999

  Addendum to the xoon package
  Interface to the ANSWERS facility of FORUM conferences
  Works as the showme exec on VM, will look for the ANSWERS reference
  in the current append, loads the answer file which must already been
  downloaded, formats and shows the appended ANSWER in a new file

  Usage : type showme on the commandline whenever you see something like

  See LAN--002 in NT ANSWERS
  If you are linked to IBMPC on VM you can access the answers file
  by typing SHOWME at your browser prompt while viewing this append.

  Keep the ANSWERS file up to date
*/

Parse Source os invoke sourcefn .
if pos('Windows', os) | pos('OS/2', os) then do
   pathsep = '\'
end
else do
   pathsep = '/'
end

'extract /FILENAME/'

lpos = lastpos(pathsep, filename.1)
f = substr(filename.1, lpos + 1)
parse var f conf'.forum.'forum'.'article

f = LocateREF()
if f <> 0 then do
   'MSG No reference to ANSWERS file found in append...'
   return 1
end

answersfile = substr(filename.1, 1, lpos)''conf'.answers.'forum'.articles'

call showANSWER

return 0

showANSWER:

if stream(answersfile, 'C', 'QUERY EXISTS') = '' then do
  'MSG File 'answersfile' not found. Did you download ?'
  return 1
end

answerfile = '.'conf'.ANSWERS.'forum'.'ref

'edit 'answersfile
'L /:ndx.'ref'/'
if rc <> 0 then do
  'MSG Unable to locate 'ref' in 'answersfile
  return 1
end
'extract /CURLINE/'
parse var curline.1 . ':abs.'subject
'L /-----/f-'
'MARK LINE'
'down'
'L /-----/f'
if rc <> 0 then do
   'bottom'
end
else do
   'up'
end
'MARK LINE'
'edit 'answerfile
'MARK COPY'
'MARK CLEAR'
'edit 'answersfile
'qquit'
'edit 'answerfile
'SHADOW OFF'
'3'
do forever
   'extract /CURLINE/'
   parse var curline.1 tag':'data
   select
   when tag = 'From' then do
      from = strip(data)
   end
   when tag = 'Date' then do
      date = strip(data)
   end
   when tag = '' then do
      parse var curline.1 ':'tag'.'data
      select
      when tag = 'ndx' then do
         nop
      end
      when tag = 'key' then do
         nop
      end
      when tag = 'QUESTION' then do
         'exclude'
         leave
      end
         otherwise
         leave
      end
   end
      otherwise
        nop
   end
   'exclude'
end
'L /-----/f-'
'MARK'
'MARK DELETE'
'MARK DELETE'
'INPUT ----- appended on 'date' (by 'from')'
'INPUT From: 'from
'INPUT Subject: 'subject
'INPUT'

'ALT 0 0'
'BROWSE ON'

return 0

LocateREF:

'top'
'L /ANSWERS/E'
do forever
   if rc <> 0 then do
     return 1
   end
   'extract /CURLINE/'
   if pos('ANSWERS.', curline.1) <> 0 then do
      answers = 'ANSWERS.'
   end
   else do
      answers = 'ANSWERS'
   end
   apos = wordpos(answers, curline.1)
   if apos > 3  then do
      line = curline.1
   end
   else do
      'extract /CURSOR/'
      'extract /LINE 'cursor.1 - 1'/'
      line = line.1' 'curline.1
      apos = wordpos(answers, line)
   end
   if apos > 3 then do
      ref   = word(line, apos - 3)
      in    = word(line, apos - 2)
      forum = word(line, apos - 1)
      if translate(in) = 'IN' then do
         return 0
      end
   end
   'REPEAT_FIND'
end

