/***************************************************************************/
/*                                                                         */
/* Add the specified number of lines to the display.  We loop through the  */
/* file, looking for excluded lines.  If we find a group, we display them, */
/* then exclude lines from the middle if necessary.  We must set SHADOW on */
/* for this to work, but we restore the setting after we're done.  We also */
/* save and restore the current line number.                               */
/*                                                                         */
/* Usage is SPREAD <N>, where N defaults to 1.                             */
/* Requires version 1.60 of the editor, or later.                          */
/*                                                                         */
/* Written by B. Thompson, May 9, 1995                                     */
/*                                                                         */
/***************************************************************************/

  Parse Arg numtoadd .
  If \Datatype(numtoadd,'N')
    Then numtoadd = 1                                 /* Default value is 1*/
  numtoshow = numtoadd * 2

  'EXTRACT /SHADOW/'                              /* Initial shadow setting*/
  'EXTRACT /CURSOR/'                             /* Initial cursor position*/
  'SHADOW ON'
  'TOP'

  Do While rc = 0 | rc = 16
    'EXTRACT /CURLINE/'
    If curline.2 = 0
      Then Do                                   /* Current line is excluded*/
        'SHOW' curline.3
        If rc = 10
          Then curline.3 = curline.3 - 1                  /* Adjust for EOF*/
        If curline.3 > numtoshow
          Then Do                          /* We must re-exclude some lines*/
            'UP' curline.3 - numtoadd
            'EXCLUDE' curline.3 - numtoshow
            'DOWN' numtoadd
          End
      End
    'DOWN 1'
  End                                                             /* End do*/

  'SHADOW' shadow.1
  'CURSOR' cursor.1 cursor.2
Exit
