/***************************************************************************/
/*                                                                         */
/* Process output from the SUPERC program to create a file which can be    */
/* used as input to FILEMAN.  We leave only those files which SUPERC       */
/* flagged as being the same in two directories.                           */
/*                                                                         */
/* Written by B. Thompson, November 15, 1993                               */
/* Make sure we start at TOF, September 12, 1994                           */
/* Remove compiled filetypes for DIFF option, December 22, 1994            */
/*                                                                         */
/***************************************************************************/

  Parse Upper Arg opt .
  If opt = 'DIFF'
    Then startcol = 6                          /* Show only the differences*/
    Else startcol = 1

  'TOP'
  Do Forever                                      /* Process each file line*/
    'EXTRACT /CURLINE/'
    If Substr(curline.1,startcol,3) == '  *' & Length(curline.1) > 23
      Then Do                                        /* Files are identical*/
        Parse Var curline.1 . Name .
        'REPLACE' Name
        'DOWN'
      End
      Else 'DELETE'                                         /* Files differ*/
    If rc <> 0
      Then Leave                                             /* We hit EOF!*/
  End                                                             /* End do*/

  If startcol = 6
    Then Do                                                  /* DIFF option*/
      'MACRO REMOVE /.ERR/'
      'MACRO REMOVE /.EXE/'
      'MACRO REMOVE /.MAP/'
      'MACRO REMOVE /.OBJ/'
      'MACRO REMOVE /.RES/'
    End

Exit
