/***************************************************************************/
/*                                                                         */
/* TAGS.X                                                                  */
/*                                                                         */
/* Look for the token at the cursor position, and jump to its definition.  */
/* Uses output from the Exuberant CTAGS program, which is available from   */
/* http://darren.hiebert.com/ctags/.                                       */
/*                                                                         */
/* To generate the TAGS file (must be in the current directory) issue the  */
/* CTAGS command with a list of files to be parsed, e.g.                   */
/*                                                                         */
/*   ctags <options> *.c *.h                                               */
/*                                                                         */
/* You may use the --excmd=number option to generate line numbers, or use  */
/* the default which will generate a search string to use to find the      */
/* definition.                                                             */
/*                                                                         */
/* To look for the token, position the cursor at its beginning and press   */
/* the key assigned to this macro, or call it from the command line.       */
/*                                                                         */
/* Written by Blair Thompson, January 22, 1999                             */
/*                                                                         */
/***************************************************************************/

  tagsfile = 'tags'

  'EXTRACT /CURLINE/'
  'EXTRACT /CURSOR/'
  token = Substr(curline.1,cursor.2)
  token = Word(token,1)                             /* Only take first word*/
  Parse Var token token '(' .             /* Remove any possible parameters*/
  Parse Var token token '&' .
  Parse Var token token '*' .
  Parse Var token token ',' .
  Parse Var token token ':' .
  Parse Var token token '<' .
  Parse Var token token '}' .
  If token = ''
    Then Do
      'MSG No token found for Tags'
      Return
    End

  'EDIT -q' tagsfile
  '0'
  'LOCATE /'token'/ fe'
  If rc <> 0
    Then Do
      'RESTORE_FIND'
      'QUIT'
      'msgmode on'
      'MSG' token 'not found in' tagsfile
      Exit
    End                                                           /* End do*/
    Else Do
      'EXTRACT /CURLINE/'
      Parse Var curline.1 . fn line ';' .
      If \Datatype(line,'W')
        Then Do
          Parse Var curline.1 . . searchcmd '$/;"' .
          searchcmd = Strip(searchcmd,'L')
          If Substr(searchcmd,1,2) = '/^'
            Then searchcmd = Substr(searchcmd,3)
        End                                                       /* End do*/
    End

  'RESTORE_FIND'
  'QUIT'
  If fn <> ''
    Then Do
      'EDIT -top' fn
      If Datatype(line,'W')
        Then 'CURSOR' line
        Else Do
          'LOCATE /'searchcmd'/ fe'
          'RESTORE_FIND'
        End
    End                                                           /* End do*/
    Else Do 
      'msgmode on'
      'MSG Error finding' token 'in' tagsfile
    End
  'msgmode on'
Exit
