/***************************************************************************/
/*                                                                         */
/* XDIR - show a directory in a window                                     */
/*                                                                         */
/* Written by Rob Johnston                                                 */
/* Modified by B. Thompson to traverse sub-directories, February 8, 1996   */
/* Modified by C. Raymond  to display parent directory, February 13, 1996  */
/* Modified by B. Thompson to highlight sub-directories, February 16, 1996 */
/*                                                                         */
/***************************************************************************/
   Parse Arg parm .
   Parse source . . macroname '.' .                          /* Who are we?*/

   /* Make sure something was typed in */
   If parm = ''
     Then parm = directory()
   If Pos('*',parm) = 0
     Then parm = parm||'\*'

   call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
   call SysLoadFuncs
   'EXTRACT /ESCAPE/'

   /* Call the system to get a stub of the directory    */
   /* Note that it gets both files and subdirectories.. */
   call SysFileTree parm , 'file', 'B'

   If file.0 = 0
     Then do
       'MSG No files found'
     end
     Else do
       /* Count the number of backslashes (needed for parent directory     */
       /* display routine below).  Use file 1, see below.                  */
       Parse Var file.1 . . . . therest
       bslash = 0;
       Do While( pos('\',therest) <> 0 )
          Parse value therest with first '\' therest
          bslash = bslash + 1
       End                                                        /* End do*/
       numFiles = file.0
       If (bslash > 1) Then                      /* If not at root dir, add*/
          numFiles = numFiles + 1                  /* 1 more line to window*/

       /* Define window to hold files/directories.                         */
       'WINDOW 8 50 'numFiles' Dir of' parm

       /* Loop through files/subdirectories                                */
       Do i = 1 to (file.0 )
          Parse Var file.i . . . attribs therest
          newline =''
          /* search for a backslash, make sure any '\'s in the filenames   */
          /* are translated to a '\\' before we put them in the window     */
          If (pos('\',therest) <> 0 )
            Then do
               Do while( pos('\',therest) <> 0 )
                 parse value therest with first '\' therest
                 newline = newline||first||'\\'
               End                                                /* End do*/
               newline = newline||therest
             end
             else
               newline = file.i
          If Substr(attribs,2,1) = 'D'
            Then newline = escape.1'E'newline '<DIR>\nMACRO' macroname newline
            Else newline = newline'\nedit 'newline

          /* Add this file/subdirectory to the window                      */
          'WINLINE 'newline
       End                                                        /* End do*/

       /* Since the SysFileTree call above does not go up the directory    */
       /* tree, we are going to manually create a parent directory entry.  */
       /* Use file 1 as the starting point to determine the parent dir.    */
       /* There has to be at least 1 file or we wouldn't be here.          */
       /* If there is more than 1 backslash add parent dir entry.          */
       If (bslash > 1) Then Do
          Parse Var file.1 . . . . therest
          newline =''
          slash = bslash;
          /* Loop thru 1 less than # of backslashes to remove filename.    */
          Do While (slash > 1)
             Parse value therest with first '\' therest
             If (slash > 2) Then
                newline = newline||first||'\\'
             /* Don't want last 2 backslashes in output                    */
             Else
                newline = newline||first
             slash = slash - 1;
          End                                                     /* End do*/
          /* Add parent dir entry to window.                               */
          newline = Escape.1'E'newline '<DIR>\nMACRO' macroname newline
          'WINLINE 'newline
       End                                                        /* End if*/
      End
Exit
