/* ----------------------------------------------------------------- */
/* function:                                                         */
/*    dir into current file at line after cursor                     */
/* ----------------------------------------------------------------- */

/* ----------------------------------------------------------------- */
/* Usage :                                                           */
/*   xl path_name / options                                          */
/*                  options := "S"  short listing                    */
/*                             "R"  recurse sub directories          */
/* ----------------------------------------------------------------- */

/* ----------------------------------------------------------------- */
/* Doc   :                                                           */
/*   self explaining ( I Hope|)                                      */
/* ----------------------------------------------------------------- */

Trace "O"

Parse Upper Arg xParms
parse var xParms xPath "/" xOptions

Xl_Path = strip(xPath)
If Xl_Path = "" Then ,
   Xl_path = "*.*"

xOptions = strip(xOptions)
If verify(xOptions,"RS") <> 0 then
   Xl_Opts = "F"
Else
   /* -------------------------------------------------------------- */
   /* beware of the concat operator                                  */
   /* change it to the right one for os2 REXX                        */
   /*            VV                                                  */
   /* -------------------------------------------------------------- */
   Xl_Opts = "F" || translate(xOptions,"SO","RS")

If RxFuncQuery('SysLoadFuncs') Then Do
   Call RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
   Call SysLoadFuncs
End

Call SysFileTree Xl_Path , "files" , Xl_Opts

If files.0 > 0 Then do

   "EXTRACT /SIZE/"
   lines = size.1

   /* -------------------------------------------------------------- */
   /* changed "EXTRACT /CURSOR" to "EXTRACT /CURSOR/"                */
   /* -------------------------------------------------------------- */
   "EXTRACT /CURSOR/"
   "CURSOR " cursor.1   1

   Do i = 1 to files.0
      "INPUT "strip(Files.i)
   End
   "CURSOR " cursor.1+1 1

   "MSG *XL - " Files.0 "Files Listed "

End
Else do

   "MSG *XL - No Matching Files Found "

End

/* ----------------------------------------------------------------- */
/* if the file was empty reset alt count                             */
/* ----------------------------------------------------------------- */
If lines < 2  Then ,
   "ALT 0 0"

/* ----------------------------------------------------------------- */
/*                                                                   */
/* ----------------------------------------------------------------- */
exit

