/*+--------------------------------------------------------------------------+*/
/*|  X2 To Html Converson tool                                               |*/
/*|                                                                          |*/
/*|     Convert an X2 edit session into an html document suitable for        |*/
/*|     browsing or printing with you favorite web browser.                  |*/
/*|                                                                          |*/
/*|                                                                          |*/
/*|  author:  Wesley J. Miller - IBM Retail Store Solutions, Raleigh, NC     |*/
/*+--------------------------------------------------------------------------+*/

   /*<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><> */
   /*<>                     Begin User Input Section                       <> */
   /*<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><> */

   /*+-----------------------------------------------------------------------+*/
   /*| USER CONTROL VARIABLES                                                |*/
   /*|                                                                       |*/
   /*|  Change the values in the following lines to set your default         |*/
   /*|  preferences.                                                         |*/
   /*|                                                                       |*/
   /*|  Here are some default install paths for IE and Netscape              |*/
   /*|                                                                       |*/
   /*|   WinXX  Netscape  c:\progra~1\netscape\communicator\program\netscape |*/
   /*|          IE        c:\progra~1\plus!\micros~1\iexplore                |*/
   /*|                                                                       |*/
   /*|   OS/2   Netscape  c:\netscape\program\netscape                       |*/
   /*|                                                                       |*/
   /*+-----------------------------------------------------------------------+*/
   browserPath = 'D:\PROGRAM_FILES\NETSCAPE\PROGRAM\NETSCAPE.EXE'
   browserPath = 'c:\progra~1\netscape\communicator\program\netscape'
                            /* enter the fully qualified path (including the  */
                            /* name of the executable) to your favorite web   */
                            /* browser.  You may omit the path info if your   */
                            /* browser is in your default path.               */

   print       = 0          /*  0 = prepare output for browsing               */
                            /*  1 = prepare output for printing               */

   numberLines = 1          /*  0 = Lines in hte output will not be numbered  */
                            /*  1 = Lines in hte output will be numbered      */

   bgcolour    = 'DEFAULT'  /* 'DEFAULT'       Background colour will be the  */
                            /*                 background colour assigned to  */
                            /*                 "data" in the editor           */
                            /* colourname      any valid HTML colour name     */

   ResizeFonts = 0          /* 0 = output has no font enlargements            */
                            /* 1 = output enhanced w/ font enlargements       */

   SendToBrowser = 1        /* 0 = save output to file, don't send to browser */
                            /* 1 = save putput to file and send to browser    */

   author_name = 'Wesley J. Miller'
                            /* your name                                      */

   /* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>*/
   /* <>                     End of User Input Section                      <>*/
   /* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>*/

   /* set our version number ------------------------------------------------ */
   xtoh_version = '2.2'

   /* get the user's input -------------------------------------------------- */
   parse arg    opString                                /* get our arguments  */
   call ParseCommandLine  opString                      /* go hadnle the args */

   /* apply the user input plus any defaults to get set up ------------------ */
   call SETUP

   /* find out which OS this is and set the path separator and temp dir ----- */
   'extract \os'

   select
      when os.1 = 'OS/2'  then do
         pathSep = '\'                                      /* path separator */
         temppath = value('tmp',, 'Environment')
         if temppath = ''
            then temppath = 'c:\'
       end                                                            /* when */

      when word( os.1, 1 ) = 'Windows'  then do
         os.1 = 'WINDOWS'
         pathSep = '\'                                      /* path separator */
         temppath = value('temp',, 'Environment')
         if temppath = ''
            then temppath = 'c:\'
       end                                                            /* when */

      otherwise
         os.1 = 'OTHER'
         pathSep = '/'
         temppath = '~/'
    end                                                             /* select */

   /* determine the current and output filenames ---------------------------- */
   'extract \name'                    /* get the current filename             */
   p = lastpos( '.' , name.1 )        /* find the last dot in the filename    */
   if p = 0                           /* if there is no dot in the filename   */
      then p = length( name.1 ) + 1   /* pretend there is one at the end      */

   fn  = substr( name.1, 1, p-1 )     /* start with the part before the dot   */
   q   = lastpos( pathSep , fn )      /* find the last path separator         */
   fn  = substr( fn, q + 1 )          /* filename is part after separator     */

   ext = substr( name.1, p+1 )        /* extension is the part after last dot */
   if translate( ext ) = 'htm'        /* just in case the extension is 'htm'  */
      then newExt = ''                /*    use a null new extension          */
      else newExt = '.htm'            /*    otherwise use 'htm' as new ext.   */

   srcFN = name.1                     /* save the old filename                */
   newFN = temppath||pathSep||fn||newExt    /* make the new filename          */

   /* record our position in the current file ------------------------------- */
   'extract \cursor'                  /* where is the cursor now?             */
   SrcRow = cursor.1
   SrcCol = cursor.2

   'extract \flscreen'                /* row number at the top of screen      */
   SrcTop = flscreen.1

   /* see if there is a mark set -------------------------------------------- */
   'extract \mark'

   /* if no mark set in current file, dummy up the mark coordinates --------- */
   if mark.0 = 0 | mark.1 <> srcFN then do   /* if there was no mark set....  */
      'extract \size'                        /* get the file size             */
      mark.2 = 1                             /* top line of "mark"            */
      mark.3 = size.1                        /* bottom line of "mark"         */
      mark.4 = 0                             /* 0 = line mark not block mark  */
    end   /* then ........................................................... */

   /* if we number lines, we need to know how many cols the numbers will need */
   numberSize = length( mark.3 )          /* length of row number of last row */

   /* initialize a stem to hold our output and start filling it ------------- */
   m = 0    ;  output.    = ''
   m = m + 1;  output.m   = '<html>'
   m = m + 1;  output.m   = '<head>'
   m = m + 1;  output.m   = '   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">'
   m = m + 1;  output.m   = '   <meta name="Author" content="'author_name'">'
   m = m + 1;  output.m   = '   <title>'name.1'</title>'
   m = m + 1;  output.m   = '</head>'
   m = m + 1;  output.m   = '<body bgcolor='bgcolour'>'
   m = m + 1;  output.m   = '<font face="courier new">'
   m = m + 1;  output.m   = '<pre>'
   m = m + 1;  output.m   = '<font size=+2><b><u>X2 to HTML Conversion</u></b></font> version:' xtoh_version
   m = m + 1;  output.m   = ' '
   m = m + 1;  output.m   = '<font size=+2><b>Filename:  </b></font>'  name.1
   m = m + 1;  output.m   = '<font size=+2><b>  Author:  </b></font>' author_name
   m = m + 1;  output.m   = '<font size=+2><b>    Date:  </b></font>' date()
   m = m + 1;  output.m   = '<br><hr><br>'

   /* step through the source/mark line by line ----------------------------- */
   do row = mark.2 to mark.3                          /* for each row         */
      'cursor' row                                    /* go to next row       */
      'extract \curline'                              /* get its contents     */

      /* get substring from the marked columns ------------------------------ */
      if mark.4 > 0                                   /* for a block mark     */
         then do
            text = substr( curline.1 , mark.4, (mark.5 - mark.4 + 1))
            startcol = mark.4
            endcol   = mark.5
          end                                               /* if    then ... */
         else do                      /* for a line mark or dummy-ed up mark **/
            text = curline.1
            startcol = 1
            endcol   = length( text )
          end                                               /* if    ... else */

      /* if the text is blank ----------------------------------------------- */
      if text = '' then do                                     /* empty line? */
         m = m + 1                      /* just stuff in an empty output line */
         if numberlines = 1                          /* well, maybe number it */
            then output.m = right( row, numberSize )
            else output.m = ' '
         iterate                               /* no need for more processing */
       end   /* then ........................................................ */

      /* get the linecolours for this row ----------------------------------- */
      'extract \linecolour'

      /* parse the colours by field within the selected columns ------------- */
      /* go right to left to prevent clobbering input data ------------------ */
      do j = linecolour.0 to 1 by -1
         parse var linecolour.j col1 col2 colourString   /* parse linecolours */
         colourString = strip( colourString )            /* no stray spaces   */

         if col1 > endcol |  col2 < startcol         /* not in our col range? */
            then iterate                             /* skip this colouring   */

         /* handle user specified colour settings --------------------------- */
         if datatype( colourString ) <> 'NUM' then do
            parse var colourString colourString 'ON' .     /* foreground only */
            colourString = translate( space( colourString , 0 ))
            if wordpos( colourString , colourList ) > 0     /* known colour?  */
               then     colourString = colour.colourString  /* use definition */
            tag.colourString  = '<font color="'colourString'">'  /* make tag  */
            etag.colourString = '</font>'                        /* make etag */
          end   /* then ..................................................... */

         /* left shift column boundaries since the text substring starts in   */
         /* column one ------------------------------------------------------ */
         if col1 < startcol           /* match colour boundary to left column */
            then col1 = startcol

         col1 = col1 - startcol + 1         /* left shift cols in text substr */
         col2 = col2 - startcol + 1         /* left shift cols in text substr */

         /* process the text to compensate for ampersands and less-than signs */

         /* get the actual text to be decorated ----------------------------- */
         lp   = substr( text, 1, col1 - 1 )                      /* left part */
         slug = substr( text, col1, col2 - col1 + 1  )     /* part to work on */
         rp   = substr( text, col2 + 1 )                        /* right part */

         /* convert ampersands into '&amp;'s -------------------------------- */
         p = pos( '&' , slug )                               /* find next '&' */
         do while p > 0                                  /* if a '&' is found */
            before  = substr( slug, 1, p-1 )                /* part before it */
            after   = substr( slug, p+1 )                    /* part after it */
            slug = before'&amp;'after             /* replace '&' with '&amp;' */
            p = pos( '&' , slug, p+1 )                /* look for another '&' */
          end   /* end while ................................................ */

         /* convert less-thans into '&lt;'s --------------------------------- */
         do while pos( '<' , slug ) > 0                   /* lok for all '<'s */
            parse var slug before '<' after    /* get what's before and after */
            slug = before'&lt;'after               /* replace '<' with '&lt;' */
          end   /* end do ................................................... */

         /* assemble the tags and text -------------------------------------- */
         text = lp || tag.colourString || slug || etag.colourString || rp

       end   /* do .......................................................... */

      /* add line numbers? -------------------------------------------------- */
      if numberLines = 1
         then   text = right( row, numberSize ) text

      /* copy composed line into output stem --------------------------------- */
      m = m + 1
      output.m = text

    end   /* do ............................................................  */

   /* close up the last of the tags ----------------------------------------- */
   m = m + 1; output.m   = '</pre>'
   m = m + 1; output.m   = '</font>'
   m = m + 1; output.m   = '</body>'
   m = m + 1; output.m   = '</html>'

   /* set output.0 to the count of lines ------------------------------------ */
   output.0 = m

   /* save the results into the new file --------------------DDDDDDDDDDDDDDDD */
   'x' newFN                                 /* open new file                 */
   'top'                                     /* goto its top                  */
   'delete *'                                /* delete anything that is there */
   do i = 1 to output.0
      'input' output.i                       /* input our output              */
    end   /* do ............................................................  */
   'file'

   /* <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>*/

   /* restore the screen and cursor -------------------------DDDDDDDDDDDDDDDD */
   'x' srcFN                           /* return to the source file           */
   'topline' srctop                    /* put the screen back where it was    */
   'cursor' srcRow SrcCol              /* put the cursor back where it was    */

   /* call browser to show the file? ---------------------------------------- */
   if SendToBrowser = 1                /* user wants to send to the brower?   */
      then do
         select
            when os.1 = 'OS/2'    then  'start /f /n' browserPath newfn
            when os.1 = 'WINDOWS' then  'start' browserPath newfn
            otherwise
               browserPath newfn
          end                                                       /* select */
       end                                                  /* if    then ... */
      else  'messagebox XtoHTML',
                  '`n`n-- File saved as:' newfn '--'
   exit

SETUP:

   /* ------------------------------------------------------------------------*/
   /*  SETUP - generate our internal variables and constants.                 */
   /* ------------------------------------------------------------------------*/

   /* defined colours in X2 ------------------------------------------------- */
   /*                                                                         */
   /* Available foreground colours:                                           */
   /*   Black, Blue, Brown, Cyan, Dark Grey*, Green, Light Blue*, Light       */
   /*   Cyan*, Light Green*, Light Grey, Light Magenta*, Light Red*, Magenta, */
   /*   Red, White*, and Yellow*.                                             */
   /*                                                                         */
   /* ------------------------------------------------------------------------*/

   /* colour map for the standard X2 coloours ------------------------------- */
                        /* RRGGBB */  /* HTML colour name ------------------- */
   BLACK        = '#000000'           /*     black                            */
   BLUE         = '#0000FF'           /*     blue                             */
   BROWN        = '#996633'           /*     brown                            */
   CYAN         = '#00FFFF'           /*     cyan                             */
   DARKGREY     = '#808080'
   GREEN        = '#00CC00'
   LIGHTBLUE    = '#81E8FF'
   LIGHTCYAN    = '#82FFFF'
   LIGHTGREEN   = '#00FF00'           /*     gren                             */
   LIGHTGREY    = '#C0C0C0'
   LIGHTMAGENTA = '#FF00FF'           /*     purple                           */
   LIGHTRED     = '#FF6666'
   MAGENTA      = '#C400C4'
   RED          = '#FF0000'           /*     red                              */
   WHITE        = '#FFFFFF'           /*     white                            */
   YELLOW       = '#FFFF00'           /*     yelow                            */
   colourList = 'BLACK BLUE BROWN CYAN DARKGREY GREEN LIGHTBLUE LIGHTCYAN' ,
                'LIGHTGREEN LIGHTGREY LIGHTMAGENTA LIGHTRED MAGENTA RED',
                'WHITE YELLOW'

   ALT_KEYWORDS  = 1
   BROWSE_DATA   = 2
   COMMENT       = 5
   DATA          = 6
   ERROR_LINE    = 7
   FUNCTION_NAME = 9
   KEYWORDS      = 11
   QUOTES        = 21
   SHADOW        = 22

   /* get the colours assigned to the X2 fields ----------------------------- */
   'extract \colours'

   /* determine the names of the coloured areas ----------------------------- */
   area_list = ''
   do clr = 1 to colours.0
      parse var colours.clr area_name .
      area_list = area_list area_name
    end                                                                 /* do */

   /* associate constants with the standard X2 coloured areas --------------- */
   ALT_KEYWORDS  = wordpos( "ALT_KEYWORDS " , area_list )
   BROWSE_DATA   = wordpos( "BROWSE_DATA  " , area_list )
   COMMENT       = wordpos( "COMMENT      " , area_list )
   DATA          = wordpos( "DATA         " , area_list )
   ERROR_LINE    = wordpos( "ERROR_LINE   " , area_list )
   FUNCTION_NAME = wordpos( "FUNCTION_NAME" , area_list )
   KEYWORDS      = wordpos( "KEYWORDS     " , area_list )
   QUOTES        = wordpos( "QUOTES       " , area_list )
   SHADOW        = wordpos( "SHADOW       " , area_list )

   /* decode the background and foreground colours for the areas ------------ */
   parse var colours.ALT_KEYWORDS  . fg.ALT_KEYWORDS  'ON' bg.ALT_KEYWORDS
   parse var colours.BROWSE_DATA   . fg.BROWSE_DATA   'ON' bg.BROWSE_DATA
   parse var colours.COMMENT       . fg.COMMENT       'ON' bg.COMMENT
   parse var colours.DATA          . fg.DATA          'ON' bg.DATA
   parse var colours.ERROR_LINE    . fg.ERROR_LINE    'ON' bg.ERROR_LINE
   /* special case - parses at the 'ON' in function! */
   parse var colours.FUNCTION_NAME . 'ON' . fg.FUNCTION_NAME 'ON' bg.FUNCTION_NAME
   parse var colours.KEYWORDS      . fg.KEYWORDS      'ON' bg.KEYWORDS
   parse var colours.QUOTES        . fg.QUOTES        'ON' bg.QUOTES
   parse var colours.SHADOW        . fg.SHADOW        'ON' bg.SHADOW

   /* clean up the colour strings ------------------------------------------- */
   fg.ALT_KEYWORDS    = value(space( fg.ALT_KEYWORDS  , 0 ))
   fg.BROWSE_DATA     = value(space( fg.BROWSE_DATA   , 0 ))
   fg.COMMENT         = value(space( fg.COMMENT       , 0 ))
   fg.DATA            = value(space( fg.DATA          , 0 ))
   fg.ERROR_LINE      = value(space( fg.ERROR_LINE    , 0 ))
   fg.FUNCTION_NAME   = value(space( fg.FUNCTION_NAME , 0 ))
   fg.KEYWORDS        = value(space( fg.KEYWORDS      , 0 ))
   fg.QUOTES          = value(space( fg.QUOTES        , 0 ))
   fg.SHADOW          = value(space( fg.SHADOW        , 0 ))

   bg.ALT_KEYWORDS    = value(space( bg.ALT_KEYWORDS  , 0 ))
   bg.BROWSE_DATA     = value(space( bg.BROWSE_DATA   , 0 ))
   bg.COMMENT         = value(space( bg.COMMENT       , 0 ))
   bg.DATA            = value(space( bg.DATA          , 0 ))
   bg.ERROR_LINE      = value(space( bg.ERROR_LINE    , 0 ))
   bg.FUNCTION_NAME   = value(space( bg.FUNCTION_NAME , 0 ))
   bg.KEYWORDS        = value(space( bg.KEYWORDS      , 0 ))
   bg.QUOTES          = value(space( bg.QUOTES        , 0 ))
   bg.SHADOW          = value(space( bg.SHADOW        , 0 ))

   /* if we are just going to print ----------------------------------------- */
   if print = 1
      then do
         /*-------------------------------------------------------------------*/
         /*     Default Text Attributes for Printing                          */
         /*-------------------------------------------------------------------*/
         /*                     | Bold | Undr | Ital                          */
         /*                     +------+------+-------------------------------*/
         /* 1  = ALT_KEYWORDS   | x    | x    |                               */
         /* 2  = BROWSE_DATA    |      |      |                               */
         /* 5  = COMMENT        |      | x    | x                             */
         /* 6  = DATA           |      |      |                               */
         /* 7  = ERROR_LINE     | x    | x    | x                             */
         /* 9  = FUNCTION_NAME  | x    |      |                               */
         /* 11 = KEYWORDS       | x    |      |                               */
         /* 21 = QUOTES         |      |      | x                             */
         /* 22 = SHADOW         | x    |      |                               */
         /*-------------------------------------------------------------------*/
         tag.ALT_KEYWORDS    = '<b><u>'      ; etag.ALT_KEYWORDS   = '</u></b>'
         tag.BROWSE_DATA     = ''            ; etag.BROWSE_DATA    = ''
         tag.COMMENT         = '<i>'         ; etag.COMMENT        = '</i>'
         tag.DATA            = ''            ; etag.DATA           = ''
         tag.ERROR_LINE      = '<b><u><i>'   ; etag.ERROR_LINE     = '</i></u></b>'
         tag.FUNCTION_NAME   = '<b>'         ; etag.FUNCTION_NAME  = '</b>'
         tag.KEYWORDS        = '<b>'         ; etag.KEYWORDS       = '</b>'
         tag.QUOTES          = '<i>'         ; etag.QUOTES         = '</i>'
         tag.SHADOW          = ''            ; etag.SHADOW         = ''

         /* if the user wants the function names enlarged ------------------- */
         if ResizeFonts = 1 then do
            tag.FUNCTION_NAME   = '<font size=+1>'   || tag.FUNCTION_NAME
            etag.FUNCTION_NAME  = etag.FUNCTION_NAME || '</font>'
          end     /* then ................................................... */

         bgcolour = WHITE                 /* background is white for printing */
       end     /* then ...................................................... */

      else do                                      /* we aren't just printing */
         tag.ALT_KEYWORDS    = '<font color="' || fg.ALT_KEYWORDS  || '"><b><u>'
         etag.ALT_KEYWORDS   = '</u></b></font>'

         tag.BROWSE_DATA     = '<font color="' || fg.BROWSE_DATA   || '">'
         etag.BROWSE_DATA    = '</font>'

         tag.COMMENT         = '<font color="' || fg.COMMENT       || '"><i>'
         etag.COMMENT        = '</i></font>'

         tag.DATA            = '<font color="' || fg.DATA          || '">'
         etag.DATA           = '</font>'

         tag.ERROR_LINE      = '<font color="' || fg.ERROR_LINE    || '"><b><u><i>'
         etag.ERROR_LINE     = '</i></u></b></font>'

         tag.FUNCTION_NAME   = '<font color="' || fg.FUNCTION_NAME || '"><b>'
         etag.FUNCTION_NAME  = '</b></font>'

         tag.KEYWORDS        = '<font color="' || fg.KEYWORDS      || '"><b>'
         etag.KEYWORDS       = '</b></font>'

         tag.QUOTES          = '<font color="' || fg.QUOTES        || '"><i>'
         etag.QUOTES         = '</i></font>'

         tag.SHADOW          = '<font color="' || fg.SHADOW        || '">'
         etag.SHADOW         = '</font>'

         /* handle the user's choice (or lack thereof) for background colour  */
         bgcolour = translate( bgcolour )                /* roll to uppercase */
         if wordpos( bgcolour , colourList ) > 0             /* known colour? */
            then     bgcolour = colour.bgcolour      /* use colour definition */
         else if bgcolour = 'DEFAULT'                    /* colour = default? */
            then     bgcolour = bg.DATA         /* use data background colour */

       end     /* else ...................................................... */

 return   /* ................................................................ */

ParseCommandLine:

   /*+-----------------------------------------------------------------------+*/
   /*|  Parse the command line looking for abbreviations and parms which     |*/
   /*|  consume multiple tokens.                                             |*/
   /*+-----------------------------------------------------------------------+*/
   parse arg    opString                    /* get our arguments              */

   opString = strip( opString )             /* remove leading/trailing spaces */
   do while opString <> ''                  /* do while there are options     */
      parse var opString opt opString       /* next one word is next option   */
      opString = strip( opString )          /* clean off newly exposed blanks */
      opt = translate( opt )                /* roll opt to uppercase          */

      select                                /* select based on opt ---------- */
         /* opt = heLP ------------------------------------------------------ */
         when wordpos( opt , '? -? /? HELP -HELP /HELP' ) > 0 then do
            "window" 16 76 29 'Help for XtoHTML'
            "winline                                                                             \n NOP"
            "winline +--------------------------------------------------------------------------+\n NOP"
            "winline | XtoHTML - Converts the file currently loaded into X2 to HTML suitable    |\n NOP"
            "winline |           for browsing or printing.  If a mark is present in the file,   |\n NOP"
            "winline |           the output is only the mark contents.  Otherwise, the entire   |\n NOP"
            "winline |           file is converted.                                             |\n NOP"
            "winline |                                                                          |\n NOP"
            "winline | >>- xtohtml -.---------.-.-----------------.-.-----------------------.-< |\n NOP"
            "winline |              +- Print -+ +- Numberlines ---+ +- Bgcolor --.- colour -'   |\n NOP"
            "winline |              '- View --' '- Unnumberlines -' '- Bgcolour -'              |\n NOP"
            "winline |                                                                          |\n NOP"
            "winline |               >--.--------.-.--------.-.---------------------.---<<      |\n NOP"
            "winline |                  +- File -+ +- Enhance -+ '- Author authorname D'        |\n NOP"
            "winline |                  '- Show -' '- Onefont -'                                |\n NOP"
            "winline | where:                                                                   |\n NOP"
            "winline |                                                                          |\n NOP"
            "winline |  Print              - produces output suitable for printing              |\n NOP"
            "winline |  View               - produces output suitable for browser viewing       |\n NOP"
            "winline |  Numberlines        - prefixes line numbers to output lines              |\n NOP"
            "winline |  Unnumberlines      - stops line numbering                               |\n NOP"
            "winline |  Bgcolor | Bgcolour - sets the browse mode background colour to <colour> |\n NOP"
            "winline |  File               - save output file - do not call browser             |\n NOP"
            "winline |  Show               - send output to browser and save output file        |\n NOP"
            "winline |  Enhance            - produces print output with font enhancements       |\n NOP"
            "winline |  Onefont            - produces print output all in the same font         |\n NOP"
            "winline |  Author             - sets the author's name to the remaing text of the  |\n NOP"
            "winline |                       arguments.  Author must be specified last.         |\n NOP"
            "winline |                                                                          |\n NOP"
            "winline +--------------------------------------------------------------------------+\n NOP"
            exit
          end   /* when  .................................................... */

         /* opt = PRINT ----------------------------------------------------- */
         when   abbrev(  "PRINT" , opt , 1 ) > 0 ,
              | abbrev( "-PRINT" , opt , 2 ) > 0 ,
              | abbrev( "/PRINT" , opt , 2 ) > 0     then print = 1=1

         /* opt = PRINT ----------------------------------------------------- */
         when   abbrev(  "VIEW" , opt , 1 ) > 0 ,
              | abbrev( "-VIEW" , opt , 2 ) > 0 ,
              | abbrev( "/VIEW" , opt , 2 ) > 0      then print = 1=0

         /* opt = ENHANCE --------------------------------------------------- */
         when   abbrev(  "ENHANCE" , opt , 1 ) > 0 ,
              | abbrev( "-ENHANCE" , opt , 2 ) > 0 ,
              | abbrev( "/ENHANCE" , opt , 2 ) > 0   then ResizeFonts = 1=1

         /* opt = ONEFONT --------------------------------------------------- */
         when   abbrev(  "ONEFONT" , opt , 1 ) > 0 ,
              | abbrev( "-ONEFONT" , opt , 2 ) > 0 ,
              | abbrev( "/ONEFONT" , opt , 2 ) > 0   then ResizeFonts = 1=0

         /* opt = FILE ------------------------------------------------------ */
         when   abbrev(  "FILE" , opt , 1 ) > 0 ,
              | abbrev( "-FILE" , opt , 2 ) > 0 ,
              | abbrev( "/FILE" , opt , 2 ) > 0      then SendToBrowser = 1=0

         /* opt = SHOW ------------------------------------------------------ */
         when   abbrev(  "SHOW" , opt , 1 ) > 0 ,
              | abbrev( "-SHOW" , opt , 2 ) > 0 ,
              | abbrev( "/SHOW" , opt , 2 ) > 0      then SendToBrowser = 1=1

         /* opt = UNNUMBERLINES --------------------------------------------- */
         when   abbrev(  "UNNUMBERLINES" , opt , 1 ) > 0 ,
              | abbrev( "-UNNUMBERLINES" , opt , 2 ) > 0 ,
              | abbrev( "/UNNUMBERLINES" , opt , 2 ) > 0     then numberLines = 1=1

         /* opt = NUMBERLINES ----------------------------------------------- */
         when   abbrev(  "NUMBERLINES" , opt , 1 ) > 0 ,
              | abbrev( "-NUMBERLINES" , opt , 2 ) > 0 ,
              | abbrev( "/NUMBERLINES" , opt , 2 ) > 0       then numberLines = 1=1

         /* opt = BGCOLOR - consumes next token ----------------------------- */
         when   abbrev(  "BGCOLOR"  , opt , 1 ) > 0 ,
              | abbrev( "BGCOLOUR"  , opt , 1 ) > 0 ,
              | abbrev( "-BGCOLOR"  , opt , 2 ) > 0 ,
              | abbrev( "/BGCOLOR"  , opt , 2 ) > 0 ,
              | abbrev( "-BGCOLOUR" , opt , 2 ) > 0 ,
              | abbrev( "/BGCOLOUR" , opt , 2 ) > 0
                 then do
                    parse var opString bgColour opString/* next word is color */
                    bgcolour = translate( bgcolour ) /* roll opt to uppercase */
                  end   /* when  ............................................ */

         /* opt = AUTHOR --- must be last option----------------------------- */
         when   abbrev(  "AUTHOR" , opt , 1 ) > 0 ,
              | abbrev( "-AUTHOR" , opt , 2 ) > 0 ,
              | abbrev( "/AUTHOR" , opt , 2 ) > 0
                 then do
                    author_name = opString /* rest of opString is author name */
                    opString = ''              /* so there is no opSting left */
                  end   /* when  ............................................ */

         otherwise
            'messagebox XtoHTML',
                  '`n`n Unknown opton "'opt'" was ignored.',
                  '`n`n Press enter to continue or "?" for help.'
            if result = '?'
               then opString = '?' opString
       end                             /*select                               */

    end                                /*do                                   */
 return     /*................................................................*/

